module Ecoportal
  module API
    module Common
      class Response

        attr_reader :status, :body

        def initialize(response)
          @status = response.status
          @body   = [].tap do |body_data|
            response.body.each do |chunk|
              body_data << chunk
            end
          end.join("")
          @body   = JSON.parse(@body.to_s) rescue nil
          response
        end

        def success?
          @status.success?
        end

        def print_pretty
          puts "Status: #{@status.code}"
          puts "Body:"
          puts JSON.pretty_generate(@body)
        end
      end
    end
  end
end
