module Ecoportal
  module API
    class Internal < V1
      include Common::Logging

      VERSION = "v0"
      class_resolver :people_class,  "Ecoportal::API::Internal::People"
      class_resolver :person_schemas_class,  "Ecoportal::API::Internal::PersonSchemas"

      class_resolver :policy_groups_class,  "Ecoportal::API::Internal::PolicyGroups"
      class_resolver :login_providers_class,  "Ecoportal::API::Internal::LoginProviders"

      # Obtain specific object for policy groups api requests.
      # @return [PolicyGroups] an instance object ready to make policy groups api requests.
      def policy_groups
        policy_groups_class.new(client)
      end

      # Obtain specific object for login providers api requests.
      # @return [LoginProviders] an instance object ready to make login providers api requests.
      def login_providers
        login_providers_class.new(client)
      end
    end
  end
end

require 'ecoportal/api/internal/person_schemas'
require 'ecoportal/api/internal/policy_groups'
require 'ecoportal/api/internal/login_providers'
require 'ecoportal/api/internal/people'
