module Ecoportal
  module API
    class Internal
      class Preferences < Common::BaseModel
        passthrough  :kiosk_enabled, :kiosk_workflow_message, :kiosk_create_button_label,
            :kiosk_create_button_help, :kiosk_return_button_label, :kiosk_return_button_help,
            :kiosk_dashboard_button_label, :kiosk_dashboard_button_help

        [
          :show_sidebar,
          :show_shortcuts,
          :show_coming_soon,
          :show_recently_visited_forms,
          :show_tasks,
          :show_task_bubbles
        ].map(&:to_s).each do |field|
          define_method(field) do
            if doc.key?(field)
              doc[field]
            else
              true
            end
          end
          define_method("#{field}=") do |value|
            doc[field] = !!value
          end
        end
      end
    end
  end
end
